<?php

	App::uses('CakeEventListener', 'Event');

	class DeliveryCalculatorListener implements CakeEventListener {

		public function implementedEvents() {
			return array(
				'Model.Order.updateOrderTotal' => 'calculateDeliveryCost',
			);
		}

		public function calculateDeliveryCost(CakeEvent $event) {
			
			$orderTotal = $event->data['Order']['Order']['subtotal'] + $event->data['Order']['Order']['vat'];
			

			

			//Check if site settings allows free delivery over a given threshold 
			$freeShippingThreshold = Configure::read('SiteSetting.free_delivery_threshold');

			//Check if free shipping applies
			if($freeShippingThreshold !== null  && $freeShippingThreshold <= $orderTotal) {

				$event->data['Order']['Order']['delivery_cost'] = 0;

			} elseif(Configure::read('SiteSetting.fixed_delivery_cost') !== null) {

				$event->data['Order']['Order']['delivery_cost'] = Configure::read('SiteSetting.fixed_delivery_cost');
				
			}

			//Update total 
			$event->data['Order']['Order']['total'] += $event->data['Order']['Order']['delivery_cost'];

		}

	}
